﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SyncfusionMvcApplication22;
using System.Runtime.Serialization;
using Syncfusion.JavaScript.Shared.Serializer;
using System.ComponentModel.DataAnnotations;
using System.Web.UI.WebControls;
using System.ComponentModel;
using System.Reflection;


namespace SyncfusionMvcApplication22.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
        public ActionResult GridFeatures()
        {
            var DataSource = GetInversedData();
            ViewBag.datasource = DataSource;
            ViewData["EmployeeID"] = EmployeeID;
            return View();
        }

        public class DMSerial : IDataSourceSerializer
        {
            public string Serialize(object obj)
            {
                var str = Newtonsoft.Json.JsonConvert.SerializeObject(obj);
                return str;
            }
        }

        public static List<Details> GetInversedData()
        {
            List<Details> obj = new List<Details>();
            for (var i = 0; i < 1; i++)
            {
                obj.Add(new Details() { OrderID = 10001, OrderDate = new DateTime(2010, 1, 1), FirstName = "Nancy", LastName = "Davolio", Title = "Sales Representative", LocationType = LocationType.INTNS });
                obj.Add(new Details() { OrderID = 10002, OrderDate = new DateTime(2011, 1, 12), FirstName = "Andrew", LastName = "Fuller", Title = "Vice President, Sales", LocationType = LocationType.INTS });
                obj.Add(new Details() { OrderID = 10003, OrderDate = new DateTime(2012, 1, 3), FirstName = "Janet", LastName = "Leverling", Title = "Sales Representative", LocationType = LocationType.EST });
                obj.Add(new Details() { OrderID = 10004, OrderDate = new DateTime(2013, 1, 14), FirstName = "Margaret", LastName = "Peacock", Title = "Sales Representative", LocationType = LocationType.INTS });
                obj.Add(new Details() { OrderID = 10005, OrderDate = new DateTime(2014, 1, 5), FirstName = "Steven", LastName = "Buchanan", Title = "Sales Manager", LocationType = LocationType.EST });
                obj.Add(new Details() { OrderID = 10006, OrderDate = new DateTime(2015, 1, 6), FirstName = "Michael", LastName = "Suyama", Title = "Sales Representative", LocationType = LocationType.EST });
                obj.Add(new Details() { OrderID = 10007, OrderDate = new DateTime(2016, 1, 13), FirstName = "Robert", LastName = "King", Title = "Sales Representative", LocationType = LocationType.INTS });
                obj.Add(new Details() { OrderID = 10008, OrderDate = new DateTime(2017, 1, 1), FirstName = "Laura", LastName = "Callahan", Title = "Inside Sales Coordinator", LocationType = LocationType.EST });
            }
            return obj;
            
        }
        public List<object> EmployeeID
        {

            get
            
            {
                var EmployeeID = new List<object>();

                Type enumType = typeof(LocationType);    
     
    // I will get all values and iterate through them    
    var enumValues = enumType.GetEnumValues();

    foreach (LocationType value in enumValues)
    { 
        MemberInfo memberInfo =
            enumType.GetMember(value.ToString()).First();  
        var descriptionAttribute =
            memberInfo.GetCustomAttribute<DescriptionAttribute>();
        LocationType eval2 = value;
          int value1 = (int) eval2;
        EmployeeID.Add(new { value = value, text = descriptionAttribute.Description });

    }
    return EmployeeID;
            }
        }

        public class Details
        {
            public int OrderID { get; set; }
            public DateTime OrderDate { get; set; }
            public string FirstName { get; set; }
            public string LastName { get; set; }
            public string Title { get; set; }
            [DisplayName("Location Type")]
            public LocationType? LocationType { get; set; }
        }

        public enum LocationType
        {
            [Description("Description 1")]
            EST = 1,
            [Description("Description 2")]
            INTNS = 2,
            [Description("Description 3")]
            INTS = 3
        }
    }
}
